#ifndef	LOCALPROTO_H
#define LOCALPROTO_H

#undef	MANX
#undef	LATTICE
#include "compiler.h"
#include "foob.h"

/* Prototypes for functions defined in sysinit.c */
VOID sysinit    PROTO((void));
VOID syscleanup PROTO((void));

/* Prototypes for functions defined in amiga_maps.c */

/* Prototypes for functions defined in spawn.c */
int spawncli    PROTO((int f, int n));

#ifdef	MANX
/* Prototypes for functions defined in malloc.c */
char           *lmalloc PROTO((unsigned int size));
char           *malloc PROTO((unsigned int size));
int free        PROTO((char *blk));
#endif

/* Prototypes for functions defined in dirio.c */
char           *getwd PROTO((char *path));
int chdir       PROTO((char *path));

/* Prototypes for functions defined in ttyicon.c */
int tticon      PROTO((int f, int n));

/* Prototypes for functions defined in fileio.c */
int ffropen     PROTO((char *fn));
int ffwopen     PROTO((char *fn));
int ffclose     PROTO((void));
int ffgetline   PROTO((char *buf, int nbuf, int *nbytes));
int fbackupfile PROTO((char *fname));
#ifdef	FOOB
FOOB getfoob    PROTO((char *fname));
VOID putfoob    PROTO((char *name, FOOB mask));
#endif
char           *startupfile PROTO((VOID));
char           *adjustname PROTO((char *fn));
VOID FlushBuf   PROTO((void));
int FillBuf     PROTO((void));
/* int Strcmp PROTO((char *s1, char *s2)); */
/* This is a lie, caused by CBM lieing about struct FileLock *... sigh */
unsigned long PathName PROTO((long, char *pwdstr, long nentries));
int copy        PROTO((char *, char *));

/* Prototypes for functions defined in ttymouse.c */
int amigamouse  PROTO((int f, int n));
int mreposition PROTO((int f, int n));
int mdelfword   PROTO((int f, int n));
int mkillline   PROTO((int f, int n));
int mforwdel    PROTO((int f, int n));
int mdelwhite   PROTO((int f, int n));
int mkillregion PROTO((int f, int n));
int myank       PROTO((int f, int n));
int mforwpage   PROTO((int f, int n));
int mbackpage   PROTO((int f, int n));
int msplitwind  PROTO((int f, int n));
int mdelwind    PROTO((int f, int n));
int mgotobob    PROTO((int f, int n));
int mgotoeob    PROTO((int f, int n));
int menlargewind PROTO((int f, int n));
int mshrinkwind PROTO((int f, int n));

/* Prototypes for functions defined in ttyio.c */
int ttopen      PROTO((void));
VOID tthide     PROTO((int resize));
VOID ttshow     PROTO((int resize));
VOID ttclose    PROTO((void));
int togglewindow PROTO((int f, int n));
int togglezooms PROTO((int f, int n));
int setfont     PROTO((int f, int n));
VOID ttputc     PROTO((unsigned char c));
VOID ttflush    PROTO((void));
VOID ttnflush   PROTO((int n));
int ttgetc      PROTO((void));
int ttwait      PROTO((void));
VOID setttysize PROTO((void));
VOID panic      PROTO((char *s));
int typeahead   PROTO((void));

/* Prototypes for functions defined in tty.c */
VOID ttinit     PROTO((void));
VOID tttidy     PROTO((void));
VOID ttmove     PROTO((int row, int col));
VOID tteeol     PROTO((void));
VOID tteeop     PROTO((void));
VOID ttbeep     PROTO((void));
VOID asciiparm  PROTO((int n));
VOID ttinsl     PROTO((int row, int bot, int nchunk));
VOID ttdell     PROTO((int row, int bot, int nchunk));
VOID ttwindow   PROTO((int top, int bot));
VOID ttnowindow PROTO((void));
VOID ttcolor    PROTO((int color));
VOID ttresize   PROTO((void));
int ttmode      PROTO((int f, int n));
int tttext      PROTO((int f, int n));
int textforeground PROTO((int f, int n));
int textbackground PROTO((int f, int n));
int modeforeground PROTO((int f, int n));
int modebackground PROTO((int f, int n));

/* Prototypes for functions defined in rexx.c */
void openrexx 
PROTO((void));
void closerexx 
PROTO((void));
int disprexx    PROTO((struct MsgPort *));
int rexxcommand PROTO((int f, int n));
int rexxexitcommand PROTO((int f, int n));
int rexxbuffer  PROTO((int f, int n));
int rexxbuflist PROTO((int f, int n));
int rexxregion  PROTO((int f, int n));
int rexxdisplay PROTO((int f, int n));
int rexxinsert  PROTO((int f, int n));
int rexxline    PROTO((int f, int n));
int rexxcomregion PROTO((int f, int n));
int rexxmark    PROTO((int f, int n));
int rexxpoint   PROTO((int f, int n));
int rexxrequest PROTO((int f, int n));
int rexxreqbuf  PROTO((int f, int n));
int rexxreqfunc PROTO((int f, int n));
int rexxreqmacro PROTO((int f, int n));
int rexxwindow  PROTO((int f, int n));
int rexxlock    PROTO((int f, int n));
int rexxunlock  PROTO((int f, int n));
int rexxwait    PROTO((int f, int n));
int rexxtopwindow PROTO((int f, int n));

/* Prototypes for functions defined in ttymenu.c */
#ifdef	DO_MENU
struct Menu    *InitEmacsMenu PROTO((struct Window * EmW));
int amigamenu   PROTO((int f, int n));
int Display_File PROTO((char *dir, char *file));
/* the first arg should be a BPTR, but BPTR is undefined in a lot of the
 * sources that inherit this header
 */
int btocstr     PROTO((long bp, char *buf, int bufsiz));
#endif

/* Prototypes for functions defined in ttykbd.c */
int getkbd      PROTO((void));
VOID ttykeymapinit PROTO((void));

/* Prototypes for functions defined in sleep.c */
VOID sleep      PROTO((int n));

/* Prototypes for functions defined in menustack.c */
#ifdef	DO_MENU
VOID Menu_Init  PROTO((void));
VOID DisposeMenus PROTO((void));
VOID Menu_Pop   PROTO((void));
int Menu_Add    PROTO((char *name, int enabled, int saveit));
int Menu_Item_Add PROTO((char *name, unsigned int flags, long mux, int ch, int saveit));
int Menu_SubItem_Add PROTO((char *name, unsigned int flags, long mux, int ch, int saveit));
char           *strsave PROTO((char *string));
#endif

/* Prototypes for functions defined in console.c */
int OpenConsole PROTO((struct IOStdReq * writerequest, struct IOStdReq * readrequest, struct Window * window));
int ConPutChar  PROTO((struct IOStdReq * request, int character));
int ConPutStr   PROTO((struct IOStdReq * request, char *string));
int ConWrite    PROTO((struct IOStdReq * request, char *string, int len));
int QueueRead   PROTO((struct IOStdReq * request, char *whereto));

#endif
